import json
from functools import partial

from event_handler_base import EventHandlerBase


class EventHandler(EventHandlerBase):
    def __init__(self, anchor, event_handler_function, zmq_context=None):
        super().__init__(anchor, zmq_context)
        self.event_handler_function = event_handler_function

        def wrapper(msg_parts, handler):
            anchor, message = msg_parts
            data_json = json.loads(message)
            response = handler(data_json, self)
            encoded_response = json.dumps(response).encode('utf-8')
            self.zmq_push_socket.send_multipart([anchor, encoded_response])

        self.zmq_sub_stream.on_recv(partial(wrapper, handler=event_handler_function))
